{ config, pkgs, ...}:

{
  networking.vlans."net-uplink-a" = {
    id = 101;
    interface = "ens18";
  };
  networking.interfaces."net-uplink-a".mtu = 1600;

  networking.vlans."net-uplink-a.7" = {
    id = 7;
    interface = "net-uplink-a";
  };

  services.pppd = {
    peers.uplink-a = {
      config = ''
        plugin rp-pppoe.so net-uplink-a.7
        user "002742928961551138009163#0001@t-online.de"
        ifname ppp-uplink-a
        persist
        maxfail 0
        holdoff 5
        noipdefault
        lcp-echo-interval 20
        lcp-echo-failure 3
        mtu 1492
        hide-password
        nodefaultroute
        +ipv6
        debug
      '';
    };
  };
}
